## mlpack 4.6.0

=== DESCRIPTION ===
Package: mlpack
Title: 'Rcpp' Integration for the 'mlpack' Library
Version: 4.6.0
Date: 2025-04-03
Authors@R: c(
    person("Yashwant", "Singh Parihar", email = "yashwantsingh.sngh@gmail.com", role = c("aut", "ctb", "cph")),
    person("Ryan", "Curtin", email = "ryan@ratml.org", role = c("aut", "ctb", "cph", "cre")),
    person("Dirk", "Eddelbuettel", email = "edd@debian.org", role = c("aut", "ctb", "cph")),
    person("James", "Balamuta", email = "james.balamuta@gmail.com", role = c("aut", "ctb", "cph")),
    person("Bill", "March", email = "march@gatech.edu", role = c("ctb", "cph")),
    person("Dongryeol", "Lee", email = "dongryel@cc.gatech.edu", role = c("ctb", "cph")),
    person("Nishant", "Mehta", email = "niche@cc.gatech.edu", role = c("ctb", "cph")),
    person("Parikshit", "Ram", email = "p.ram@gatech.edu", role = c("ctb", "cph")),
    person("James", "Cline", email = "james.cline@gatech.edu", role = c("ctb", "cph")),
    person("Sterling", "Peet", email = "sterling.peet@gatech.edu", role = c("ctb", "cph")),
    person("Matthew", "Amidon", email = "mamidon@gatech.edu", role = c("ctb", "cph")),
    person("Neil", "Slagle", email = "npslagle@gmail.com", role = c("ctb", "cph")),
    person("Ajinkya", "Kale", email = "kaleajinkya@gmail.com", role = c("ctb", "cph")),
    person("Vlad", "Grantcharov", email = "vlad321@gatech.edu", role = c("ctb", "cph")),
    person("Noah", "Kauffman", email = "notoriousnoah@gmail.com", role = c("ctb", "cph")),
    person("Rajendran", "Mohan", email = "rmohan88@gatech.edu", role = c("ctb", "cph")),
    person("Trironk", "Kiatkungwanglai", email = "trironk@gmail.com", role = c("ctb", "cph")),
    person("Patrick", "Mason", email = "patrick.s.mason@gmail.com", role = c("ctb", "cph")),
    person("Marcus", "Edel", email = "marcus.edel@fu-berlin.de", role = c("ctb", "cph")),
    person("Mudit", "Raj Gupta", email = "mudit.raaj.gupta@gmail.com", role = c("ctb", "cph")),
    person("Sumedh", "Ghaisas", email = "sumedhghaisas@gmail.com", role = c("ctb", "cph")),
    person("Michael", "Fox", email = "michaelfox99@gmail.com", role = c("ctb", "cph")),
    person("Siddharth", "Agrawal", email = "siddharth.950@gmail.com", role = c("ctb", "cph")),
    person("Saheb", "Motiani", email = "saheb210692@gmail.com", role = c("ctb", "cph")),
    person("Yash", "Vadalia", email = "yashdv@gmail.com", role = c("ctb", "cph")),
    person("Abhishek", "Laddha", email = "laddhaabhishek11@gmail.com", role = c("ctb", "cph")),
    person("Vahab", "Akbarzadeh", email = "v.akbarzadeh@gmail.com", role = c("ctb", "cph")),
    person("Andrew", "Wells", email = "andrewmw94@gmail.com", role = c("ctb", "cph")),
    person("Zhihao", "Lou", email = "lzh1984@gmail.com", role = c("ctb", "cph")),
    person("Udit", "Saxena", email = "saxenda.udit@gmail.com", role = c("ctb", "cph")),
    person("Stephen", "Tu", email = "tu.stephenl@gmail.com", role = c("ctb", "cph")),
    person("Jaskaran", "Singh", email = "jaskaranvirdi@ymail.com", role = c("ctb", "cph")),
    person("Hritik", "Jain", email = "hritik.jain.cse13@itbhu.ac.in", role = c("ctb", "cph")),
    person("Vladimir", "Glazachev", email = "glazachev.vladimir@gmail.com", role = c("ctb", "cph")),
    person("QiaoAn", "Chen", email = "kazenoyumechen@gmail.com", role = c("ctb", "cph")),
    person("Janzen", "Brewer", email = "jahabrewer@gmail.com", role = c("ctb", "cph")),
    person("Trung", "Dinh", email = "dinhanhtrung@gmail.com", role = c("ctb", "cph")),
    person("Tham", "Ngap Wei", email = "thamngapwei@gmail.com", role = c("ctb", "cph")),
    person("Grzegorz", "Krajewski", email = "krajekg@gmail.com", role = c("ctb", "cph")),
    person("Joseph", "Mariadassou", email = "joe.mariadassou@gmail.com", role = c("ctb", "cph")),
    person("Pavel", "Zhigulin", email = "pashaworking@gmail.com", role = c("ctb", "cph")),
    person("Andy", "Fang", email = "AndyFang.DZ@gmail.com", role = c("ctb", "cph")),
    person("Barak", "Pearlmutter", email = "barak+git@pearlmutter.net", role = c("ctb", "cph")),
    person("Ivari", "Horm", email = "ivari@risk.ee", role = c("ctb", "cph")),
    person("Dhawal", "Arora", email = "d.p.arora1@gmail.com", role = c("ctb", "cph")),
    person("Alexander", "Leinoff", email = "alexander-leinoff@uiowa.edu", role = c("ctb", "cph")),
    person("Palash", "Ahuja", email = "abhor902@gmail.com", role = c("ctb", "cph")),
    person("Yannis", "Mentekidis", email = "mentekid@gmail.com", role = c("ctb", "cph")),
    person("Ranjan", "Mondal", email = "ranjan.rev@gmail.com", role = c("ctb", "cph")),
    person("Mikhail", "Lozhnikov", email = "lozhnikovma@gmail.com", role = c("ctb", "cph")),
    person("Marcos", "Pividori", email = "marcos.pividori@gmail.com", role = c("ctb", "cph")),
    person("Keon", "Kim", email = "kwk236@gmail.com", role = c("ctb", "cph")),
    person("Nilay", "Jain", email = "nilayjain13@gmail.com", role = c("ctb", "cph")),
    person("Peter", "Lehner", email = "peter.lehner@dlr.de", role = c("ctb", "cph")),
    person("Anuraj", "Kanodia", email = "akanuraj200@gmail.com", role = c("ctb", "cph")),
    person("Ivan", "Georgiev", email = "ivan@jonan.info", role = c("ctb", "cph")),
    person("Shikhar", "Bhardwaj", email = "shikharbhardwaj68@gmail.com", role = c("ctb", "cph")),
    person("Yashu", "Seth", email = "yashuseth2503@gmail.com", role = c("ctb", "cph")),
    person("Mike", "Izbicki", email = "mike@izbicki.me", role = c("ctb", "cph")),
    person("Sudhanshu", "Ranjan", email = "sranjan.sud@gmail.com", role = c("ctb", "cph")),
    person("Piyush", "Jaiswal", email = "piyush.jaiswal@st.niituniversity.in", role = c("ctb", "cph")),
    person("Dinesh", "Raj", email = "dinu.iota@gmail.com", role = c("ctb", "cph")),
    person("Vivek", "Pal", email = "vivekpal.dtu@gmail.com", role = c("ctb", "cph")),
    person("Prasanna", "Patil", email = "prasannapatil08@gmail.com", role = c("ctb", "cph")),
    person("Lakshya", "Agrawal", email = "zeeshan.lakshya@gmail.com", role = c("ctb", "cph")),
    person("Praveen", "Ch", email = "chvsp972911@gmail.com", role = c("ctb", "cph")),
    person("Kirill", "Mishchenko", email = "ki.mishchenko@gmail.com", role = c("ctb", "cph")),
    person("Abhinav", "Moudgil", email = "abhinavmoudgil95@gmail.com", role = c("ctb", "cph")),
    person("Thyrix", "Yang", email = "thyrixyang@gmail.com", role = c("ctb", "cph")),
    person("Sagar", "B Hathwar", email = "sagarbhathwar@gmail.com", role = c("ctb", "cph")),
    person("Nishanth", "Hegde", email = "hegde.nishanth@gmail.com", role = c("ctb", "cph")),
    person("Parminder", "Singh", email = "parmsingh101@gmail.com", role = c("ctb", "cph")),
    person("CodeAi", "", email = "benjamin.bales@assrc.us", role = c("ctb", "cph")),
    person("Franciszek", "Stokowacki", email = "franek.stokowacki@gmail.com", role = c("ctb", "cph")),
    person("Samikshya", "Chand", email = "samikshya289@gmail.com", role = c("ctb", "cph")),
    person("N", "Rajiv Vaidyanathan", email = "rajivvaidyanathan4@gmail.com", role = c("ctb", "cph")),
    person("Kartik", "Nighania", email = "kartiknighania@gmail.com", role = c("ctb", "cph")),
    person("Eugene", "Freyman", email = "evg.freyman@gmail.com", role = c("ctb", "cph")),
    person("Manish", "Kumar", email = "manish887kr@gmail.com", role = c("ctb", "cph")),
    person("Haritha", "Sreedharan Nair", email = "haritha1313@gmail.com", role = c("ctb", "cph")),
    person("Sourabh", "Varshney", email = "sourabhvarshney111@gmail.com", role = c("ctb", "cph")),
    person("Projyal", "Dev", email = "projyal@gmail.com", role = c("ctb", "cph")),
    person("Nikhil", "Goel", email = "nikhilgoel199797@gmail.com", role = c("ctb", "cph")),
    person("Shikhar", "Jaiswal", email = "jaiswalshikhar87@gmail.com", role = c("ctb", "cph")),
    person("B", "Kartheek Reddy", email = "bkartheekreddy@gmail.com", role = c("ctb", "cph")),
    person("Atharva", "Khandait", email = "akhandait45@gmail.com", role = c("ctb", "cph")),
    person("Wenhao", "Huang", email = "wenhao.huang.work@gmail.com", role = c("ctb", "cph")),
    person("Roberto", "Hueso", email = "robertohueso96@gmail.com", role = c("ctb", "cph")),
    person("Prabhat", "Sharma", email = "prabhatsharma7298@gmail.com", role = c("ctb", "cph")),
    person("Tan", "Jun An", email = "yamidarkxxx@gmail.com", role = c("ctb", "cph")),
    person("Moksh", "Jain", email = "mokshjn00@gmail.com", role = c("ctb", "cph")),
    person("Manthan-R-Sheth", "", email = "manthanrsheth96@gmail.com", role = c("ctb", "cph")),
    person("Namrata", "Mukhija", email = "namratamukhija@gmail.com", role = c("ctb", "cph")),
    person("Conrad", "Sanderson", role = c("ctb", "cph")),
    person("Thanasis", "Mattas", email = "mattasa@auth.gr", role = c("ctb", "cph")),
    person("Shashank", "Shekhar", email = "contactshashankshekhar@gmail.com", role = c("ctb", "cph")),
    person("Yasmine", "Dumouchel", email = "yasmine.dumouchel@gmail.com", role = c("ctb", "cph")),
    person("German", "Lancioni", role = c("ctb", "cph")),
    person("Arash", "Abghari", email = "arash.abghari@gmail.com", role = c("ctb", "cph")),
    person("Ayush", "Chamoli", role = c("ctb", "cph")),
    person("Tommi", "Laivamaa", email = "tommi.laivamaa@protonmail.com", role = c("ctb", "cph")),
    person("Kim", "SangYeon", email = "sy0814k@gmail.com", role = c("ctb", "cph")),
    person("Niteya", "Shah", email = "niteya.56@gmail.com", role = c("ctb", "cph")),
    person("Toshal", "Agrawal", email = "tagrawal1339@gmail.com", role = c("ctb", "cph")),
    person("Dan", "Timson", role = c("ctb", "cph")),
    person("Miguel", "Canteras", email = "mcanteras@gmail.com", role = c("ctb", "cph")),
    person("Bishwa", "Karki", email = "karkeebishwa1@gmail.com", role = c("ctb", "cph")),
    person("Mehul", "Kumar Nirala", email = "mehulkumarnirala@gmail.com", role = c("ctb", "cph")),
    person("Heet", "Sankesara", email = "heetsankesara3@gmail.com", role = c("ctb", "cph")),
    person("Jeffin", "Sam", email = "sam.jeffin@gmail.com", role = c("ctb", "cph")),
    person("Vikas", "S Shetty", email = "shettyvikas209@gmail.com", role = c("ctb", "cph")),
    person("Khizir", "Siddiqui", email = "khizirsiddiqui@gmail.com", role = c("ctb", "cph")),
    person("Tejasvi", "Tomar", email = "tstomar@outlook.com", role = c("ctb", "cph")),
    person("Jai", "Agarwal", email = "jai.bhageria@gmail.com", role = c("ctb", "cph")),
    person("Ziyang", "Jiang", email = "zij004@alumni.stanford.edu", role = c("ctb", "cph")),
    person("Rohit", "Kartik", email = "rohit.audrey@gmail.com", role = c("ctb", "cph")),
    person("Aditya", "Viki", email = "adityaviki01@gmail.com", role = c("ctb", "cph")),
    person("Kartik", "Dutt", email = "kartikdutt@live.in", role = c("ctb", "cph")),
    person("Suryoday", "Basak", email = "suryodaybasak@gmail.com", role = c("ctb", "cph")),
    person("Sriram", "S K", email = "sriramsk1999@gmail.com", role = c("ctb", "cph")),
    person("Manoranjan", "Kumar Bharti ( Nakul Bharti )", email = "knakul853@gmail.com", role = c("ctb", "cph")),
    person("Saraansh", "Tandon", email = "saraanshtandon1999@gmail.com", role = c("ctb", "cph")),
    person("Gaurav", "Singh", email = "gs8763076@gmail.com", role = c("ctb", "cph")),
    person("Lakshya", "Ojha", email = "ojhalakshya@gmail.com", role = c("ctb", "cph")),
    person("Bisakh", "Mondal", email = "bisakhmondal00@gmail.com", role = c("ctb", "cph")),
    person("Benson", "Muite", email = "benson_muite@emailplus.org", role = c("ctb", "cph")),
    person("Sarthak", "Bhardwaj", email = "7sarthakbhardwaj@gmail.com", role = c("ctb", "cph")),
    person("Aakash", "Kaushik", email = "kaushikaakash7539@gmail.com", role = c("ctb", "cph")),
    person("Anush", "Kini", email = "anushkini@gmail.com", role = c("ctb", "cph")),
    person("Nippun", "Sharma", email = "inbox.nippun@gmail.com", role = c("ctb", "cph")),
    person("Rishabh", "Garg", email = "rishabhgarg108@gmail.com", role = c("ctb", "cph")),

=== src/mlpack/bindings/CMakeLists.txt ===
# All we have to do is recurse into the subdirectories.
set(DIRS
  cli
  julia
  markdown
  python
  go
  R
  tests
)

foreach(dir ${DIRS})
  add_subdirectory(${dir})
endforeach()

set(MLPACK_SRCS ${MLPACK_SRCS} PARENT_SCOPE)
set(MLPACK_TEST_SRCS ${MLPACK_TEST_SRCS} PARENT_SCOPE)
set(MLPACK_PYXS ${MLPACK_PYXS} PARENT_SCOPE)
set(DISABLE_CFLAGS ${DISABLE_CFLAGS} PARENT_SCOPE)
set(BUILDING_PYTHON_BINDINGS ${BUILDING_PYTHON_BINDINGS} PARENT_SCOPE)

macro(group_bindings directory name methods)
  set(${name}_METHOD_MAIN_FILES "")
  set(${name}_VALID_METHODS "")

  foreach (method ${methods})
    set(filename "${CMAKE_CURRENT_SOURCE_DIR}/${directory}/${name}_${method}_main.cpp")
    if(EXISTS ${filename})
      list(APPEND ${name}_METHOD_MAIN_FILES
          ${CMAKE_CURRENT_SOURCE_DIR}/${directory}/${name}_${method}_main.cpp)
      list(APPEND ${name}_VALID_METHODS ${method})
    else()
      message(FATAL_ERROR "file: ${filename} does not exist!!")
    endif()
  endforeach()
endmacro()

include(Categories.cmake)
set(CATEGORIES ${CATEGORIES} PARENT_SCOPE)

macro(add_category name category)
  # First, make sure that the category is a valid category.
  list(FIND CATEGORIES ${category} cat_index)
  if (${cat_index} EQUAL -1)
    message(FATAL_ERROR "add_category(): unknown category ${category}!"
        "  See the categories in "
        "src/mlpack/bindings/Categories.cmake.")
  endif ()
  set(${name}_CATEGORY ${category})
endmacro()

=== src/mlpack/bindings/R/CMakeLists.txt ===
macro (not_found_return message)
  message(STATUS "${message}")
  macro (add_r_binding directory name)
    # Do nothing.
  endmacro ()

  macro (post_r_setup)
    # Do nothing.
  endmacro ()

  return()
endmacro ()

# If we are not supposed to make R bindings, define the macro so it does
# nothing and leave this file.
if (NOT BUILD_R_BINDINGS)
  not_found_return("Not building R bindings.")
endif ()

if (BUILD_R_BINDINGS)

  # If mlpack upgrade the version of dependencies, then we also have to update the version here.
  set(RcppArmadillo_Version "0.${ARMADILLO_VERSION}")
  set(RcppEnsmallen_Version "0.${ENSMALLEN_VERSION}")

  # Import find_r_module.
  include(${CMAKE_SOURCE_DIR}/CMake/FindRModule.cmake)
  find_package(R 4.0)
  if (NOT R_FOUND)
    set(R_NOT_FOUND_MSG "${R_NOT_FOUND_MSG}\n    - R")
  endif ()
  find_r_module(roxygen2)
  if (NOT R_ROXYGEN2)
    set(R_NOT_FOUND_MSG "${R_NOT_FOUND_MSG}\n    - roxygen2")
  endif ()
  find_r_module(Rcpp 0.12.12)
  if (NOT R_RCPP)
    set(R_NOT_FOUND_MSG "${R_NOT_FOUND_MSG}\n    - Rcpp")
  endif ()
  find_r_module(RcppArmadillo "${RcppArmadillo_Version}")
  if (NOT R_RCPPARMADILLO)
    set(R_NOT_FOUND_MSG "${R_NOT_FOUND_MSG}\n    - RcppArmadillo")
  endif ()
  find_r_module(RcppEnsmallen "${RcppEnsmallen_Version}")
  if (NOT R_RCPPENSMALLEN)
    set(R_NOT_FOUND_MSG "${R_NOT_FOUND_MSG}\n    - RcppEnsmallen")
  endif ()
  find_r_module(testthat)
  if (NOT R_TESTTHAT)
    set(R_NOT_FOUND_MSG "${R_NOT_FOUND_MSG}\n    - testthat")
  endif ()
  find_r_module(pkgbuild) # Required for roxygen2 with src/ directories.
  if (NOT R_PKGBUILD)
    set(R_NOT_FOUND_MSG "${R_NOT_FOUND_MSG}\n    - pkgbuild")
  endif ()

  ## We need to check here if R and other dependencies is even available, as
  ## it is require to build R-bindings.
  if (FORCE_BUILD_R_BINDINGS)
    if (NOT R_FOUND OR NOT R_RCPP OR NOT R_RCPPARMADILLO OR NOT R_RCPPENSMALLEN
        OR NOT R_ROXYGEN2 OR NOT R_TESTTHAT OR NOT R_PKGBUILD)
      unset(BUILD_R_BINDINGS CACHE)
      message(FATAL_ERROR "Could not Build R Bindings, Following modules are not available:${R_NOT_FOUND_MSG}")
    endif()
  else ()
    if (NOT R_FOUND OR NOT R_RCPP OR NOT R_RCPPARMADILLO OR NOT R_RCPPENSMALLEN
        OR NOT R_ROXYGEN2 OR NOT R_TESTTHAT OR NOT R_PKGBUILD)
      unset(BUILD_R_BINDINGS CACHE)
      not_found_return("Not building R bindings, Following modules are not available:${R_NOT_FOUND_MSG}")
    endif()
  endif ()

  add_custom_target(R ALL)

  # Now configure DESCRIPTION.
  file(READ "${CMAKE_SOURCE_DIR}/src/mlpack/core/util/version.hpp"
      VERSION_HPP_CONTENTS)
  string(REGEX REPLACE ".*#define MLPACK_VERSION_MAJOR ([0-9]+).*" "\\1"
      MLPACK_VERSION_MAJOR "${VERSION_HPP_CONTENTS}")
  string(REGEX REPLACE ".*#define MLPACK_VERSION_MINOR ([0-9]+).*" "\\1"
      MLPACK_VERSION_MINOR "${VERSION_HPP_CONTENTS}")
  string(REGEX REPLACE ".*#define MLPACK_VERSION_PATCH [\"]?([0-9x]+)[\"]?.*"
      "\\1" MLPACK_VERSION_PATCH "${VERSION_HPP_CONTENTS}")
  set(PACKAGE_VERSION
      "${MLPACK_VERSION_MAJOR}.${MLPACK_VERSION_MINOR}.${MLPACK_VERSION_PATCH}")
  if (USING_GIT)
    set(PACKAGE_DOC_VERSION "git")
  else ()
    set(PACKAGE_DOC_VERSION "${PACKAGE_VERSION}")
  endif ()

  string(TIMESTAMP PACKAGE_DATE "%Y-%m-%d")

  # We need to generate an Authors@R list using every single contributor in
  # COPYRIGHT.txt.  That takes a little bit of processing.
  file(READ "${CMAKE_SOURCE_DIR}/COPYRIGHT.txt" COPYRIGHT_TXT_CONTENTS)
  string(REGEX MATCHALL "  Copyright [0-9-]*, ([^\n]*)\n" CONTRIBUTORS_LIST
      "${COPYRIGHT_TXT_CONTENTS}")

  # These are the authors meant to be listed as 'authors' and not
  # 'contributors'.  If you contributed specifically to the R bindings, you
  # should probably be listed here, so if you're not, open a PR to fix it! :)
  set(SPECIAL_AUTHORS "Yashwant Singh Parihar" "Ryan Curtin" "Dirk Eddelbuettel"
      "James Balamuta")

  string(CONCAT AUTHORS_R "c(\n"
      "    person(\"Yashwant\", \"Singh Parihar\", "
              "email = \"yashwantsingh.sngh@gmail.com\", "
              "role = c(\"aut\", \"ctb\", \"cph\")),\n"
      "    person(\"Ryan\", \"Curtin\", email = \"ryan@ratml.org\", "
              "role = c(\"aut\", \"ctb\", \"cph\", \"cre\")),\n"
      "    person(\"Dirk\", \"Eddelbuettel\", email = \"edd@debian.org\", "
              "role = c(\"aut\", \"ctb\", \"cph\")),\n"
      "    person(\"James\", \"Balamuta\", "
              "email = \"james.balamuta@gmail.com\", "
              "role = c(\"aut\", \"ctb\", \"cph\")),")
  foreach (CONTRIBUTOR_LINE ${CONTRIBUTORS_LIST})
    # Strip 'Copyright XXXX-YYYY, '.
    string(REGEX REPLACE "^  Copyright [0-9-]*, (.*)\n$" "\\1"
        CONTRIBUTOR_FILTERED "${CONTRIBUTOR_LINE}")

    # Extract the email if it exists.
    string(REGEX MATCH "^[^<]*<(.*)>.*$" HAS_EMAIL "${CONTRIBUTOR_FILTERED}")

    # The first name is just the first space-delimited word.  (That may not
    # always be right, but we have no way to know what is a first name and last
    # name and therefore must assume.)
    string(REGEX REPLACE "^([^ ]*) .*$" "\\1" CONTRIBUTOR_FIRST_NAME
        "${CONTRIBUTOR_FILTERED}")

    # Extracting the last name is just the rest of the tokens, but the regex is
    # different depending on whether we managed to get an email.
    if (HAS_EMAIL)
      string(REGEX REPLACE "^[^<]*<(.*)>.*$" "\\1" CONTRIBUTOR_EMAIL
          "${CONTRIBUTOR_FILTERED}")
      string(REGEX MATCH "^[^ ]* (.*) <.*$" CONTRIBUTOR_LAST_NAME
          "${CONTRIBUTOR_FILTERED}")
      if (NOT CONTRIBUTOR_LAST_NAME)
        set (CONTRIBUTOR_LAST_NAME "")
      else ()
        string(REGEX REPLACE "^[^ ]* (.*) <.*$" "\\1" CONTRIBUTOR_LAST_NAME
            "${CONTRIBUTOR_FILTERED}")
      endif ()

      # Skip anyone already listed as an author.
      if ("${CONTRIBUTOR_FIRST_NAME} ${CONTRIBUTOR_LAST_NAME}" IN_LIST
          SPECIAL_AUTHORS)
        continue()
      endif ()

      string(CONCAT AUTHORS_R "${AUTHORS_R}\n    "
          "person(\"${CONTRIBUTOR_FIRST_NAME}\", \"${CONTRIBUTOR_LAST_NAME}\", "
          "email = \"${CONTRIBUTOR_EMAIL}\", role = c(\"ctb\", \"cph\")),")

    else ()
      # No email is available.  So just get the last name.
      string(REGEX MATCH "^[^ ]* (.*)$" CONTRIBUTOR_LAST_NAME
          "${CONTRIBUTOR_FILTERED}")
      if (NOT CONTRIBUTOR_LAST_NAME)
        set (CONTRIBUTOR_LAST_NAME "")
      else ()
        string(REGEX REPLACE "^[^ ]* (.*)$" "\\1" CONTRIBUTOR_LAST_NAME
            "${CONTRIBUTOR_FILTERED}")
      endif ()

      # Skip anyone already listed as an author.
      if ("${CONTRIBUTOR_FIRST_NAME} ${CONTRIBUTOR_LAST_NAME}" IN_LIST
          SPECIAL_AUTHORS)
        continue()
      endif ()

      string(CONCAT AUTHORS_R "${AUTHORS_R}\n    "
          "person(\"${CONTRIBUTOR_FIRST_NAME}\", \"${CONTRIBUTOR_LAST_NAME}\", "
          "role = c(\"ctb\", \"cph\")),")
    endif ()
  endforeach ()
  # We also have to remove the final comma...
  string(REGEX REPLACE ",$" "" AUTHORS_R_OUT "${AUTHORS_R}")
  set(AUTHORS_R "${AUTHORS_R_OUT})")

  configure_file(${CMAKE_SOURCE_DIR}/src/mlpack/bindings/R/mlpack/DESCRIPTION.in
                 ${CMAKE_CURRENT_BINARY_DIR}/mlpack/DESCRIPTION
                 @ONLY)

  # Create the empty NAMESPACE file that will include all export functions.
  file(WRITE
      "${CMAKE_CURRENT_BINARY_DIR}/mlpack/NAMESPACE"
      "# Generated by roxygen2: do not edit by hand"
      "\n\n")

  set(CPP_SOURCES
   "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/src/r_util.cpp"
   "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/src/rcpp_mlpack.h"
   "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/src/Makevars"
   "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/src/Makevars.win"
  )

  set(R_SOURCES
    "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/R/matrix_utils.R"
    "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/R/package.R"
  )

  set(BINDINGS_SOURCES
    "${CMAKE_CURRENT_SOURCE_DIR}/get_type.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/print_doc.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/print_doc_functions.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/print_doc_functions_impl.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/print_input_param.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/get_param.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/get_printable_param.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/get_r_type.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/print_input_processing.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/print_output_processing.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/print_serialize_util.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/mlpack_main.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/R_option.hpp"
  )

  set(TESTS_SOURCES
    "${CMAKE_CURRENT_SOURCE_DIR}/tests/test_r_binding_main.cpp"
  )

  set(R_TESTTHAT_SOURCES
    "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/tests/testthat/test-R_binding.R"
  )

  set(R_TESTS_SOURCES
    "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/tests/testthat.R"
  )

  # Configure the license file.
  string(TIMESTAMP LICENSE_YEAR "%Y")
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/mlpack/LICENSE.in"
                 "${CMAKE_CURRENT_BINARY_DIR}/mlpack/LICENSE")

  add_custom_target(r_copy ALL)

  # First we have to create all the required directories for copy.
  add_custom_command(TARGET r_copy PRE_BUILD
      COMMAND ${CMAKE_COMMAND} -E make_directory
          ${CMAKE_CURRENT_BINARY_DIR}/mlpack/R/
      COMMAND ${CMAKE_COMMAND} -E make_directory
          ${CMAKE_CURRENT_BINARY_DIR}/mlpack/tests/testthat
      COMMAND ${CMAKE_COMMAND} -E make_directory
          ${CMAKE_CURRENT_BINARY_DIR}/mlpack/src/mlpack/bindings/R/tests
   )

  if (BUILD_TESTS)
    add_custom_command(TARGET r_copy PRE_BUILD
        COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different
            ${TESTS_SOURCES}
            ${CMAKE_CURRENT_BINARY_DIR}/mlpack/src/mlpack/bindings/R/tests)
  endif()

  # Copy all necessary files for building package.
  foreach(cpp_file ${CPP_SOURCES})
    add_custom_command(TARGET r_copy PRE_BUILD
        COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different
            ${cpp_file}
            ${CMAKE_CURRENT_BINARY_DIR}/mlpack/src/)
  endforeach()
  foreach(r_file ${R_SOURCES})
    add_custom_command(TARGET r_copy PRE_BUILD
        COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different
            ${r_file}
            ${CMAKE_CURRENT_BINARY_DIR}/mlpack/R/)
  endforeach()
  foreach(bindings_file ${BINDINGS_SOURCES})
    add_custom_command(TARGET r_copy PRE_BUILD
        COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different
            ${bindings_file}
            ${CMAKE_CURRENT_BINARY_DIR}/mlpack/src/mlpack/bindings/R)
  endforeach()
  add_custom_command(TARGET r_copy PRE_BUILD
      COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different
          ${R_TESTTHAT_SOURCES}
          ${CMAKE_CURRENT_BINARY_DIR}/mlpack/tests/testthat)
  add_custom_command(TARGET r_copy PRE_BUILD
      COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different
          ${R_TESTS_SOURCES}
          ${CMAKE_CURRENT_BINARY_DIR}/mlpack/tests)
  # This file will take care of multiple definition of functions in .cpp files.
  add_custom_command(TARGET r_copy PRE_BUILD
      COMMAND ${CMAKE_COMMAND} ARGS -E touch
          "${CMAKE_CURRENT_BINARY_DIR}/mlpack/model.txt")

  file(COPY
       "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/cleanup"
       DESTINATION
       "${CMAKE_CURRENT_BINARY_DIR}/mlpack/")

  file(COPY
       "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/inst/CITATION"
       DESTINATION
       "${CMAKE_CURRENT_BINARY_DIR}/mlpack/inst")

  # Do the actual build.
  add_custom_target(r_build ALL)

  # "model.txt" is no longer useful, after generating src/.cpp files.
  # Remove this file.
  add_custom_command(TARGET r_build POST_BUILD
      COMMAND ${CMAKE_COMMAND} ARGS -E remove -f "model.txt"
      WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/mlpack"
  )

  # Build RcppExports.cpp/.R, NAMESPACE and man/ files.
  add_custom_command(TARGET r_build POST_BUILD
      COMMAND ${RSCRIPT_EXECUTABLE} ARGS "-e" "'Rcpp::compileAttributes()'"
      COMMAND ${RSCRIPT_EXECUTABLE} ARGS "-e" "'roxygen2::roxygenize(\".\")'"

=== src/mlpack/bindings/julia/CMakeLists.txt ===
macro (not_found_return message)
  message(STATUS "${message}")
  macro (add_julia_binding directory name)
    # Do nothing.
  endmacro ()

  return()
endmacro ()

macro (post_julia_setup)
  # If we are building Julia bindings, we have to end the 'module' declaration in
  # mlpack.jl.
  if (BUILD_JULIA_BINDINGS)
    file(APPEND
        "${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/src/mlpack.jl"
        "\nend\ninclude(\"functions.jl\")\ninclude(\"serialization.jl\")\nend\n")
  endif ()
endmacro ()

# If we are not supposed to make Julia bindings, define the macro so it does
# nothing and leave this file.
if (NOT BUILD_JULIA_BINDINGS)
  not_found_return("Not building Julia bindings.")
endif ()

if (BUILD_JULIA_BINDINGS)
  ## We need to check here if Julia is even available.  Although actually
  ## technically, I'm not sure if we even need to know!  For the tests though we
  ## do.  So it's probably a good idea to check.
  if (FORCE_BUILD_JULIA_BINDINGS)
    find_package(Julia 0.7.0)
    if (NOT JULIA_FOUND)
      unset(BUILD_JULIA_BINDINGS CACHE)
      message(FATAL_ERROR "Julia not found; cannot build Julia bindings!")
    endif()
  else ()
    find_package(Julia 0.7.0)
    if (NOT JULIA_FOUND)
      unset(BUILD_JULIA_BINDINGS CACHE)
    endif()
  endif ()

  if (NOT JULIA_FOUND)
      not_found_return("Julia not found; not building Julia bindings.")
  endif ()

  add_custom_target(julia ALL)

  add_custom_command(TARGET julia PRE_BUILD
      COMMAND ${CMAKE_COMMAND} -E make_directory
          ${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/src/)

  add_library(mlpack_julia_util
    julia_util.h
    julia_util.cpp)
  if (BUILD_SHARED_LIBS)
    target_link_libraries(mlpack_julia_util ${MLPACK_LIBRARIES})
  else ()
    target_link_libraries(mlpack_julia_util -static ${MLPACK_LIBRARIES})
  endif ()
  target_compile_definitions(mlpack_julia_util PUBLIC
      -DMLPACK_PRINT_INFO -DMLPACK_PRINT_WARN)
  set_target_properties(mlpack_julia_util PROPERTIES
      LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/src/")
  add_dependencies(julia mlpack_julia_util)

  # Now configure Project.toml.
  file(READ "${CMAKE_SOURCE_DIR}/src/mlpack/core/util/version.hpp"
      VERSION_HPP_CONTENTS)
  string(REGEX REPLACE ".*#define MLPACK_VERSION_MAJOR ([0-9]+).*" "\\1"
      MLPACK_VERSION_MAJOR "${VERSION_HPP_CONTENTS}")
  string(REGEX REPLACE ".*#define MLPACK_VERSION_MINOR ([0-9]+).*" "\\1"
      MLPACK_VERSION_MINOR "${VERSION_HPP_CONTENTS}")
  string(REGEX REPLACE ".*#define MLPACK_VERSION_PATCH [\"]?([0-9x]+)[\"]?.*"
      "\\1" MLPACK_VERSION_PATCH "${VERSION_HPP_CONTENTS}")

  set(PACKAGE_VERSION
      "${MLPACK_VERSION_MAJOR}.${MLPACK_VERSION_MINOR}.${MLPACK_VERSION_PATCH}")

  get_property(CYTHON_INCLUDE_DIRECTORIES DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      PROPERTY INCLUDE_DIRECTORIES)
  configure_file(
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/mlpack/Project.toml.in
      ${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/Project.toml)
  # Configure params.jl.in with the right suffix for libraries.
  configure_file(
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/mlpack/params.jl.in
      ${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/src/params.jl)

  # Create the empty mlpack.jl file that we will fill with includes using the
  # exsiting template.  Unfortunately COPY doesn't let us change the extension
  # so we need a follow-up RENAME command.
  file(COPY
       "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/mlpack.jl.in"
       DESTINATION
       "${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/src/")
  file(RENAME
       "${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/src/mlpack.jl.in"
       "${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/src/mlpack.jl")

  file(WRITE
      "${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/src/functions.jl"
      "# This file imports all of the mlpack functions into the mlpack module."
      "\n\n")

  file(WRITE
      "${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/src/types.jl"
      "# This file defines all of the mlpack types."
      "\n\n")

  file(WRITE
      "${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/src/serialization.jl"
      "# This file imports all serialization and deserialization functions\n"
      "# from internal modules.\n"
      "import Serialization\n"
      "\n"
      "\"\"\"\n"
      "    serialize_bin(stream::IO, model)\n"
      "\n"
      "Serialize an mlpack model `model` in the binary cereal format to the \n"
      "given `stream`.  Example:\n"
      "\n"
      "```julia\n"
      "_, model, _, _ = mlpack.logistic_regression(training=x, labels=y)\n"
      "mlpack.serialize_bin(open(\"model.bin\", \"w\"), model)\n"
      "```\n"
      "\n"
      "The model can later be loaded with `mlpack.deserialize_bin()`, or even\n"
      "from mlpack bindings in other languages.  However, the format used\n"
      "here will *not* work with Julia's `Serialization` package!  Use\n"
      "`Serialization.serialize()` instead.\n"
      "\"\"\"\n"
      "function serialize_bin(stream::IO, model) end\n"
      "\n"
      "\"\"\"\n"
      "    deserialize_bin(stream::IO, model_type::Type)\n"
      ""
      "Deserialize an mlpack model type from an input stream.  Specify the \n"
      "type of the model manually with the `t` argument.  Example usage:\n"
      "\n"
      "```julia\n"
      "lr_model = mlpack.deserialize_bin(stream, LogisticRegression)\n"
      "```\n"
      "\n"
      "Only use this if you have saved the model in the cereal binary format \n"
      "using `serialize_bin()` or an mlpack binding in another language!  If \n"
      "you used `Serialization.serialize()` to serialize your model, then use\n"
      "`Serialization.deserialize()` to deserialize it.\n"
      "\n"
      "Then, the returned model can be passed to appropriate mlpack functions\n"
      "for machine learning tasks.\n"
      "\"\"\"\n"
      "function deserialize_bin(stream::IO, t::Type) end"
      "\n\n")
endif ()

include("${CMAKE_SOURCE_DIR}/CMake/julia/AppendType.cmake")
include("${CMAKE_SOURCE_DIR}/CMake/julia/AppendSerialization.cmake")

macro (add_julia_binding directory name)
if (BUILD_JULIA_BINDINGS)
  # We have to take multiple steps.

  # 1. Generate julia_${name}.h and julia_${name}.cpp.
  add_custom_command(OUTPUT
      ${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/build/julia_${name}.h
      ${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/build/julia_${name}.cpp
      COMMAND ${CMAKE_COMMAND}
          -DPROGRAM_NAME=${name}
          -DPROGRAM_MAIN_FILE=${CMAKE_CURRENT_SOURCE_DIR}/${directory}/${name}_main.cpp
          -DSOURCE_DIR=${CMAKE_SOURCE_DIR}
          -DJULIA_H_IN=${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/julia_method.h.in
          -DJULIA_H_OUT=${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/build/julia_${name}.h
          -DJULIA_CPP_IN=${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/julia_method.cpp.in
          -DJULIA_CPP_OUT=${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/build/julia_${name}.cpp
          -P ${CMAKE_SOURCE_DIR}/CMake/julia/ConfigureJuliaHCPP.cmake
      DEPENDS ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/julia_method.h.in
              ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/julia_method.cpp.in
              ${CMAKE_SOURCE_DIR}/CMake/julia/ConfigureJuliaHCPP.cmake)

  # 2. Append any types to the list of types and serialization imports (this is
  # done immediately, not as a separate target).
  append_type(
      "${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/src/types.jl"
      "${name}"
      "${CMAKE_CURRENT_SOURCE_DIR}/${directory}/${name}_main.cpp")
  append_serialization(
      "${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/src/serialization.jl"
      "${name}"
      "${CMAKE_CURRENT_SOURCE_DIR}/${directory}/${name}_main.cpp")

  # 3. Build libmlpack_julia_${name}.so.
  add_library(mlpack_julia_${name}
      ${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/build/julia_${name}.h
      ${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/build/julia_${name}.cpp)
  if (BUILD_SHARED_LIBS)
    target_link_libraries(mlpack_julia_${name} mlpack_julia_util)
  else ()
    target_link_libraries(mlpack_julia_${name} -static mlpack_julia_util)
  endif ()
  target_compile_definitions(mlpack_julia_${name} PUBLIC
      -DMLPACK_PRINT_INFO -DMLPACK_PRINT_WARN)
  set_target_properties(mlpack_julia_${name} PROPERTIES
      LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/src/")

  # 4. Generate ${name}.jl.
  add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/build/generate_jl_${name}.cpp
      COMMAND ${CMAKE_COMMAND}
          -DNAME=${name}
          -DGENERATE_CPP_IN=${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/generate_jl.cpp.in
          -DGENERATE_CPP_OUT=${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/build/generate_jl_${name}.cpp
          -DPROGRAM_MAIN_FILE=${CMAKE_CURRENT_SOURCE_DIR}/${directory}/${name}_main.cpp
          -DMLPACK_JL_LIB_SUFFIX=${CMAKE_SHARED_LIBRARY_SUFFIX}
          -P ${CMAKE_SOURCE_DIR}/CMake/ConfigureFile.cmake
      DEPENDS ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/generate_jl.cpp.in
              ${CMAKE_SOURCE_DIR}/CMake/ConfigureFile.cmake)

  add_executable(generate_jl_${name}
      ${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/build/generate_jl_${name}.cpp
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/print_jl.hpp
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/print_jl.cpp
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/get_julia_type.hpp
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/get_param.hpp
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/get_printable_param.hpp
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/julia_option.hpp
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/mlpack_main.hpp
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/print_doc_functions.hpp
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/print_doc_functions_impl.hpp
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/print_input_param.hpp
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/print_input_processing.hpp
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/print_input_processing_impl.hpp
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/print_output_processing.hpp
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/print_output_processing_impl.hpp
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/print_param_defn.hpp
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/print_type_doc.hpp
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/print_type_doc_impl.hpp
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/print_model_type_import.hpp
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/default_param.hpp
      ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/julia/default_param_impl.hpp)
  if (BUILD_SHARED_LIBS)
    target_link_libraries(generate_jl_${name} ${MLPACK_LIBRARIES})
  else ()
    target_link_libraries(generate_jl_${name} -static ${MLPACK_LIBRARIES})
  endif ()
  set_target_properties(generate_jl_${name} PROPERTIES
      COMPILE_FLAGS "-DBINDING_TYPE=BINDING_TYPE_JL"
      RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/build/bin/")
  add_custom_command(TARGET generate_jl_${name} POST_BUILD
      COMMAND ${CMAKE_COMMAND}
          -DGENERATE_BINDING_PROGRAM=${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/build/bin/generate_jl_${name}
          -DBINDING_OUTPUT_FILE=${CMAKE_BINARY_DIR}/src/mlpack/bindings/julia/mlpack/src/${name}.jl
          -P ${CMAKE_SOURCE_DIR}/CMake/GenerateBinding.cmake)

  # Add the generate_jl_${name} target to the list of targets that are built
  # when 'make julia' is typed.
  add_dependencies(julia mlpack_julia_${name})
  add_dependencies(julia generate_jl_${name})

  # Append the binding to the mlpack.jl file.  (Note that this is done at
  # configuration time.)

=== src/mlpack/bindings/markdown/CMakeLists.txt ===
macro (not_found_return message)
  message(STATUS "${message}")

  macro (add_markdown_docs directory name languages category)
    # Do nothing.
  endmacro()

  function (post_markdown_setup)
    # Do nothing.
  endfunction ()

  return ()
endmacro ()

if (NOT BUILD_MARKDOWN_BINDINGS)
  not_found_return("Not building Markdown bindings.")
endif ()

# We don't need to find any libraries or anything to generate markdown
# documentation.

# Add sources for Markdown bindings.
set(SOURCES
  "binding_info.hpp"
  "binding_info.cpp"
  "default_param.hpp"
  "get_param.hpp"
  "get_printable_param.hpp"
  "get_printable_param_name.hpp"
  "get_printable_param_name_impl.hpp"
  "get_printable_type.hpp"
  "md_option.hpp"
  "mlpack_main.hpp"
  "print_doc_functions.hpp"
  "print_doc_functions_impl.hpp"
  "print_docs.hpp"
  "print_docs.cpp"
  "print_param_table.hpp"
  "print_param_table.cpp"
  "print_type_doc.hpp"
  "program_doc_wrapper.hpp"
  "replace_all_copy.hpp"
)

# Copy all Markdown sources to the build directory.
add_custom_target(markdown_copy)
add_custom_command(TARGET markdown_copy PRE_BUILD
    COMMAND ${CMAKE_COMMAND} -E make_directory
        ${CMAKE_BINARY_DIR}/src/mlpack/bindings/markdown/)
foreach(file ${SOURCES})
  add_custom_command(TARGET markdown_copy PRE_BUILD
      COMMAND ${CMAKE_COMMAND} ARGS -E copy
          ${CMAKE_CURRENT_SOURCE_DIR}/${file}
          ${CMAKE_BINARY_DIR}/src/mlpack/bindings/markdown/)
endforeach()

# Create the add_markdown_docs() macro.  It's meant to be used as
# 'add_markdown_docs(knn, "cli;python;julia")', for instance.
# See the file 'Categories.cmake' for valid categories that can be used
# by the macro.
macro (add_markdown_docs directory name languages wrappers)

  set(category ${${name}_CATEGORY})

  # Next, we should use configure_file() to generate each
  # generate_markdown.<binding>.cpp.  We need to loop over all the languages for
  # this binding to do that.
  set(BINDING ${name})

  # pushes language names to a std::vector<string>.
  set(LANGUAGES_PUSH_BACK_CODE "")

  # pushes whether wrapper is to be added for this language
  # to a std::vector<bool>.
  set(WRAPPER_PUSH_BACK_CODE "")

  # pushes method names in a group to a std::vector<string>.
  set(VALID_METHODS_PUSH_BACK_CODE "")

  # includes _main.cpp files for all methods.
  set(INCLUDE_MAIN_FILES "")

  # used to create WRAPPER_PUSH_BACK_CODE.
  set(ADD_WRAPPER_LANGUAGES "")

  # list of languages for which wrapper is to be added.
  set(WRAPPERS ${wrappers})

  foreach (lang ${languages})
    set(LANGUAGES_PUSH_BACK_CODE
        "${LANGUAGES_PUSH_BACK_CODE}\n  languages.push_back(\"${lang}\");")
    set(MARKDOWN_ALL_LANGUAGES_LIST ${MARKDOWN_ALL_LANGUAGES_LIST} ${lang})
  endforeach ()
  list(REMOVE_DUPLICATES MARKDOWN_ALL_LANGUAGES_LIST)

  foreach (lang ${languages})
    list(FIND WRAPPERS "${lang}" _idx)
    if(${_idx} EQUAL -1)
      set(ADD_WRAPPER_LANGUAGES ${ADD_WRAPPER_LANGUAGES} "false")
    else()
      set(ADD_WRAPPER_LANGUAGES ${ADD_WRAPPER_LANGUAGES} "true")
    endif()
  endforeach()

  foreach (val ${ADD_WRAPPER_LANGUAGES})
    set(WRAPPER_PUSH_BACK_CODE
        "${WRAPPER_PUSH_BACK_CODE}\n  addWrapperDocs.push_back(${val});")
  endforeach()

  if(NOT ${WRAPPERS} EQUAL "")
    foreach(method ${${name}_VALID_METHODS})
      set(VALID_METHODS_PUSH_BACK_CODE
          "${VALID_METHODS_PUSH_BACK_CODE}\n  validMethods.push_back(\"${method}\");")
    endforeach()
    foreach(loc ${${name}_METHOD_MAIN_FILES})
      set(INCLUDE_MAIN_FILES
          "${INCLUDE_MAIN_FILES}\n#include <${loc}>")
    endforeach()
  endif()

  set(INCLUDE_MAIN_FILES
      "${INCLUDE_MAIN_FILES}\n#include <${CMAKE_CURRENT_SOURCE_DIR}/${directory}/${name}_main.cpp>")

  # Do the actual file configuration.
  set(BINDING_SOURCE_DIR ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/markdown)
  set(BINDING_BINARY_DIR ${CMAKE_BINARY_DIR}/src/mlpack/bindings/markdown)

  configure_file(${BINDING_SOURCE_DIR}/generate_markdown.binding.hpp.in
      ${BINDING_BINARY_DIR}/generate_markdown.${name}.hpp)
  configure_file(${BINDING_SOURCE_DIR}/generate_markdown.binding.cpp.in
      ${BINDING_BINARY_DIR}/generate_markdown.${name}.cpp)

  # Lastly, that generate_markdown.<binding>.cpp should be added to the list of
  # files to be compiled for the 'generate_markdown' target.  We also need to
  # add information about this binding to a set of variables we have to track.
  set (MARKDOWN_SRCS ${MARKDOWN_SRCS}
      ${CMAKE_BINARY_DIR}/src/mlpack/bindings/markdown/generate_markdown.${name}.hpp
      ${CMAKE_BINARY_DIR}/src/mlpack/bindings/markdown/generate_markdown.${name}.cpp)
  set (MARKDOWN_SRCS ${MARKDOWN_SRCS} PARENT_SCOPE)
  set (MARKDOWN_NAMES ${MARKDOWN_NAMES} ${name})
  set (MARKDOWN_NAMES ${MARKDOWN_NAMES} PARENT_SCOPE)
  set (MARKDOWN_NAME_CATEGORIES ${MARKDOWN_NAME_CATEGORIES} ${category})
  set (MARKDOWN_NAME_CATEGORIES ${MARKDOWN_NAME_CATEGORIES} PARENT_SCOPE)
  set (MARKDOWN_ALL_LANGUAGES_LIST ${MARKDOWN_ALL_LANGUAGES_LIST} PARENT_SCOPE)
  set (ADD_WRAPPER_LANGUAGES ${ADD_WRAPPER_LANGUAGES} PARENT_SCOPE)
endmacro ()

# After all the methods/ directories have been traversed, we can add the
# 'generate_markdown' target.  This function is run at the bottom of
# methods/CMakeLists.txt.
function (post_markdown_setup)
  # We need to generate the program file.  This consists of generating three
  # things:
  #
  # - MARKDOWN_INCLUDES: the list of files to be included.
  # - MARKDOWN_HEADER_CODE: the code used to print the header/sidebar.
  # - MARKDOWN_CALL_CODE: the code to actually call the functions to print
  #       documentation for each binding.

  # Iterate over categories of binding.
  list(LENGTH MARKDOWN_NAMES NUM_MARKDOWN_BINDINGS)
  list(LENGTH CATEGORIES NUM_MARKDOWN_CATEGORIES)
  math(EXPR cat_limit "${NUM_MARKDOWN_CATEGORIES} - 1")
  foreach (i RANGE ${cat_limit})
    list (GET CATEGORIES ${i} cat)
    # Put the things in this category in a details block.
    string(CONCAT header_code "${MARKDOWN_HEADER_CODE}"
        "  cout << \"<li><details><summary>${cat}</summary>\" << endl;\n"
        "  cout << \"<ul>\" << endl;\n")
    set(MARKDOWN_HEADER_CODE ${header_code})

    # Add an option for this binding.
    math(EXPR range_limit "${NUM_MARKDOWN_BINDINGS} - 1")
    foreach (j RANGE ${range_limit})
      list (GET MARKDOWN_NAME_CATEGORIES ${j} category)
      if (NOT category STREQUAL cat)
        continue ()
      endif ()

      list (GET MARKDOWN_NAMES ${j} name)
      set (MARKDOWN_HEADER_CODE
          "${MARKDOWN_HEADER_CODE}\n  Print${name}Headers();")
    endforeach ()

    set (MARKDOWN_HEADER_CODE
        "${MARKDOWN_HEADER_CODE}\n"
        "  cout << \"</ul>\" << endl;\n"
        "  cout << \"</details>\" << endl;\n"
        "  cout << \"</li>\" << endl;\n"
        "  cout << endl;\n\n")
  endforeach ()

  foreach (name ${MARKDOWN_NAMES})
    set (MARKDOWN_INCLUDE_CODE
        "${MARKDOWN_INCLUDE_CODE}\n#include \"generate_markdown.${name}.hpp\"")
    set (MARKDOWN_CALL_CODE "${MARKDOWN_CALL_CODE}\n  Print${name}Docs();")
  endforeach ()

  set(BINDING_SOURCE_DIR ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/markdown)
  set(BINDING_BINARY_DIR ${CMAKE_BINARY_DIR}/src/mlpack/bindings/markdown)

  configure_file(${BINDING_SOURCE_DIR}/generate_markdown.cpp.in
      ${BINDING_BINARY_DIR}/generate_markdown.cpp)

  # Remember that this is being run from some other directory, so we have to be
  # explicit with the locations of the files we are compiling against.
  add_executable(generate_markdown
      "${BINDING_BINARY_DIR}/generate_markdown.cpp"
      ${MARKDOWN_SRCS}
      "${BINDING_SOURCE_DIR}/binding_info.hpp"
      "${BINDING_SOURCE_DIR}/binding_info.cpp"
      "${BINDING_SOURCE_DIR}/default_param.hpp"
      "${BINDING_SOURCE_DIR}/get_param.hpp"
      "${BINDING_SOURCE_DIR}/get_printable_param.hpp"
      "${BINDING_SOURCE_DIR}/get_printable_param_name.hpp"
      "${BINDING_SOURCE_DIR}/get_printable_param_name_impl.hpp"
      "${BINDING_SOURCE_DIR}/md_option.hpp"
      "${BINDING_SOURCE_DIR}/print_doc_functions.hpp"
      "${BINDING_SOURCE_DIR}/print_doc_functions_impl.hpp"
      "${BINDING_SOURCE_DIR}/print_docs.hpp"
      "${BINDING_SOURCE_DIR}/print_docs.cpp"
      "${BINDING_SOURCE_DIR}/print_param_table.hpp"
      "${BINDING_SOURCE_DIR}/print_param_table.cpp"
      "${BINDING_SOURCE_DIR}/program_doc_wrapper.hpp"
      "${BINDING_SOURCE_DIR}/replace_all_copy.hpp")
  target_link_libraries(generate_markdown ${MLPACK_LIBRARIES})
  add_dependencies(generate_markdown markdown_copy)
  set_target_properties(generate_markdown PROPERTIES
      COMPILE_FLAGS -DBINDING_TYPE=BINDING_TYPE_MARKDOWN
      RUNTIME_OUTPUT_DIRECTORY ${BINDING_BINARY_DIR})

  add_custom_target(markdown_setup ALL
      ${CMAKE_COMMAND} -E make_directory
          ${CMAKE_BINARY_DIR}/doc/
      DEPENDS generate_markdown
      COMMENT "Setting up environment for Markdown documentation build...")
  add_custom_target(markdown DEPENDS markdown_setup)
  foreach (lang ${MARKDOWN_ALL_LANGUAGES_LIST})
    add_custom_target(markdown_${lang} ALL
        COMMAND ${CMAKE_COMMAND}
            -DPROGRAM=${BINDING_BINARY_DIR}/generate_markdown
            -DPROGRAM_OPT1="${lang}"
            -DPROGRAM_OPT2="docs"
            -DOUTPUT_FILE=${CMAKE_BINARY_DIR}/doc/${lang}.md
            -P ${CMAKE_SOURCE_DIR}/CMake/RunProgram.cmake
        COMMAND ${CMAKE_COMMAND}
            -DPROGRAM=${BINDING_BINARY_DIR}/generate_markdown
            -DPROGRAM_OPT1="${lang}"
            -DPROGRAM_OPT2="sidebar"
            -DOUTPUT_FILE=${CMAKE_BINARY_DIR}/doc/${lang}.sidebar.html
            -P ${CMAKE_SOURCE_DIR}/CMake/RunProgram.cmake
        COMMENT "Building Markdown documentation for ${lang}..."
        DEPENDS markdown_setup)
    add_dependencies(markdown markdown_${lang})
  endforeach ()
endfunction ()

=== src/mlpack/bindings/tests/CMakeLists.txt ===
# Define the files we need to compile into the test executable.
# Anything not in this list will not be compiled into mlpack_test.
set(BINDING_SOURCES
  clean_memory.hpp
  clean_memory.cpp
  test_option.hpp
  ignore_check.hpp
  delete_allocated_memory.hpp
  get_allocated_memory.hpp
  get_param.hpp
  get_printable_param.hpp
  get_printable_param_impl.hpp
  mlpack_main.hpp
  test_function_map.hpp
  test_function_map.cpp
)

# Add directory name to sources.
set(DIR_SRCS)
foreach(file ${BINDING_SOURCES})
  set(DIR_SRCS ${DIR_SRCS} ${CMAKE_CURRENT_SOURCE_DIR}/${file})
endforeach()
# Append source (with directory name) to list of all mlpack sources (used at the
# parent scope).
set(MLPACK_TEST_SRCS ${MLPACK_TEST_SRCS} ${DIR_SRCS} PARENT_SCOPE)

=== debian/changelog ===
mlpack (4.6.0-1) unstable; urgency=medium

  * New upstream version
  * Forward port quilt patches
  * Bump policy
  * Build dependency for dh --with python3
  * Adjust to upstream removal of pre-C++17 support via
    src/mlpack/core/std_backport/*
  * Remove stray empty directory

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 06 Apr 2025 20:19:15 +0100

=== debian/control ===
Source: mlpack
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@alioth-lists.debian.net>
Uploaders: Barak A. Pearlmutter <bap@debian.org>
Build-Depends: cmake, debhelper-compat (= 13),
		python3-numpy-dev,
		pkgconf,
		libcereal-dev,
		libarmadillo-dev,
		libensmallen-dev (>= 2.10.0),
		libstb-dev,
		dh-python, dh-sequence-python3,
		python3, python3-dev, python3-pandas, python3-numpy, cython3, python3-setuptools,
		python3-pytest-runner, python3-pip,
		txt2man,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://www.mlpack.org/
Vcs-Git: https://salsa.debian.org/science-team/mlpack.git
Vcs-Browser: https://salsa.debian.org/science-team/mlpack

Package: libmlpack-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
	 libensmallen-dev (>= 2.10.0),
	 libarmadillo-dev, liblapack-dev,
	 libcereal-dev
Recommends: libstb-dev
Suggests: mlpack-doc
Description: intuitive, fast, scalable C++ machine learning library (development libs)
 This package contains the mlpack Library development files.
 .
 Machine Learning Pack (mlpack) is an intuitive, fast, scalable C++
 machine learning library, meant to be a machine learning analog to
 LAPACK.  It aims to implement a wide array of machine learning
 methods and function as a "swiss army knife" for machine learning
 researchers.

Package: python3-mlpack
Architecture: any
Section: python
Depends: ${misc:Depends}, ${shlibs:Depends},
	 ${python3:Depends}
Description: intuitive, fast, scalable C++ machine learning library (Python bindings)
 This package contains Python bindings for the mlpack Library.
 .
 Machine Learning Pack (mlpack) is an intuitive, fast, scalable C++
 machine learning library, meant to be a machine learning analog to
 LAPACK.  It aims to implement a wide array of machine learning
 methods and function as a "swiss army knife" for machine learning
 researchers.

Package: mlpack-bin
Section: science
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: intuitive, fast, scalable C++ machine learning library (binaries)
 This package contains example binaries using the mlpack Library.
 .
 Machine Learning Pack (mlpack) is an intuitive, fast, scalable C++
 machine learning library, meant to be a machine learning analog to
 LAPACK.  It aims to implement a wide array of machine learning
 methods and function as a “swiss army knife” for machine learning
 researchers.

Package: mlpack-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, libjs-jquery
Description: intuitive, fast, scalable C++ machine learning library (documentation)
 This package contains documentation for the mlpack Library.
 .
 Machine Learning Pack (mlpack) is an intuitive, fast, scalable C++
 machine learning library, meant to be a machine learning analog to
 LAPACK.  It aims to implement a wide array of machine learning
 methods and function as a “swiss army knife” for machine learning
 researchers.

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

# dh_python3 needs DEB_HOST_ARCH, so ... sledge hammer:
include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export LIBS="pthread"
export DESTDIR=debian/tmp

## Memory consumption issues on some autobuilders have been causing
## build failures.  There are three ways to address such issues:
## (a) reduce parallelism, e.g., dh $@ --max-parallel=2
## (b) reduce GCC memory usage, e.g., g++ --param ggc-min-expand=20 to
## reduce abrupt memory spikes, and g++ -g0 to skip debugging info.
## (c) switch to clang.

## Force Compiler to CLANG if installed. Otherwise use GCC but try to
## conserve memory. The build dependencies try to install CLANG, but
## give a dummy alternative so the build can proceed even if it is
## unavailable.
## Note: this requires build dependencies of the form
##     clang [!alpha !hppa !ia64 !m68k !sh4 !x32],
##     libomp-dev [!alpha !hppa !ia64 !m68k !sh4 !x32],

# ifeq ($(shell type clang > /dev/null && echo found),found)
# export CC=clang
# export CXX=clang++
# else

## These issues have occurred post-2.1.x in two places: Ubuntu
## Launchpad, and some particular Debian architectures including
## armhf, mips, mipsel, m68k, kfreebsd-amd64, kfreebsd-i386.

## For that reason, I am activating all of the above space-reduction
## mechanisms on Ubuntu, all 32-bit architectures, and all kfreebsd
## systems. And I am setting the build to single threaded on all
## architectures.

DH_FLAGS += --max-parallel=1

ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
SAVE_SPACE=yes
endif

ifeq ($(shell dpkg-architecture --query DEB_BUILD_ARCH_BITS),32)
SAVE_SPACE=yes
endif

ifeq ($(shell dpkg-architecture --query DEB_BUILD_ARCH_OS),kfreebsd)
SAVE_SPACE=yes
endif

ifeq ($(SAVE_SPACE),yes)
ifneq (, $(filter $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU),mips mipsel))
	export DEB_CXXFLAGS_MAINT_APPEND = --param ggc-min-expand=5 -g0
else
	export DEB_CXXFLAGS_MAINT_APPEND = --param ggc-min-expand=20 -g0
endif
endif
# endif

DO_IT_TO_JULIA=OFF
TAKE_IT_TO_GO=OFF
WHY_R_WHY_NOT=OFF

%:
	dh $@ --without python2 --with python3 --buildsystem=cmake ${DH_FLAGS}

# ON or OFF
# Fails as of 4.2.0, "17 < 17"
BUILD_TESTS=OFF

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
		-DDEBUG=ON \
		-DPROFILE=OFF \
		-DARMA_EXTRA_DEBUG=OFF \
		-DBUILD_CLI_EXECUTABLES=ON \
		-DBUILD_PYTHON_BINDINGS=ON \
		-DPYTHON_EXECUTABLE=/usr/bin/python3 \
		-DBUILD_JULIA_BINDINGS=$(DO_IT_TO_JULIA) \
		-DBUILD_GO_BINDINGS=$(TAKE_IT_TO_GO) \
		-DBUILD_R_BINDINGS=$(WHY_R_WHY_NOT) \
		-DBUILD_TESTS=$(BUILD_TESTS) \
		-DBUILD_SHARED_LIBS=ON \
		-DDISABLE_DOWNLOADS=ON \
		-DSTB_IMAGE_INCLUDE_DIR=/usr/include/stb \
		-DUSE_OPENMP=ON

ifeq ($(BUILD_TESTS),OFF)
override_dh_auto_test:
	@echo "Build time testing disabled."
endif

execute_after_dh_python3:
	dh_numpy3

execute_after_dh_install:
	@echo "use shared jquery.js javascript library"
	for f in $$(find debian/mlpack-doc -name jquery.js); do \
	  ln --verbose --symbolic --force /usr/share/javascript/jquery/jquery.js $$f; \
	done
	@echo "remove byte-compiled python files per policy"
	-find debian/python-mlpack  -name '*.pyc' -ls -delete || true
	-find debian/python3-mlpack -name '*.pyc' -ls -delete || true
	@echo "move stray documentation files into /usr/share/doc/"
	(test \! -d debian/libmlpack-dev || \
	(cd debian/libmlpack-dev && \
	 for f in $$(find usr/include -type f \! -name '*.hpp' \! -name '*.cpp'); do \
	   mkdir -p usr/share/doc/libmlpack-dev/$$(dirname $$f) && \
	   mv --verbose $$f usr/share/doc/libmlpack-dev/$$(dirname $$f)/; \
	 done))
	(test \! -d debian/python3-mlpack || \
	(cd debian/python3-mlpack && \
	 for f in $$(find usr/lib -type f -name '*.txt'); do \
	   mkdir -p usr/share/doc/python3-mlpack/$$(dirname $$f) && \
	   mv --verbose $$f usr/share/doc/python3-mlpack/$$(dirname $$f)/; \
	 done))
	@echo "remove empty directory"
	-rmdir --verbose debian/libmlpack-dev/usr/include/mlpack/core/stb/bundled

override_dh_installdocs:
	dh_installdocs -pmlpack-doc --doc-main-package libmlpack-dev
	dh_installdocs -Nmlpack-doc

override_dh_installexamples:
	dh_installexamples -pmlpack-doc --doc-main-package libmlpack-dev
	dh_installexamples -Nmlpack-doc

execute_after_dh_installexamples:
	@echo "Search and destroy stray VCS support files"
	-find debian/mlpack-doc -name .gitignore -ls -delete || true
	@echo "Remove empty directory"
	-rmdir debian/mlpack-doc/usr/share/doc/libmlpack-dev/examples/sample-ml-app/sample-ml-app/data/

override_dh_installchangelogs:
	dh_installchangelogs HISTORY.md
